$ !
$ !     @CHNAMES <table> [ <sysdev> [ <srcdev> [ <objdev> ] ] ]
$ !
$ ! This is the command proceedure which defines the logical names for the
$ ! VMS CHAOSnet system.  It assumes 3 catagories of files. The details
$ ! of which directories/files belong in which category are documented
$ ! in the body of this procedure.  In general:
$ ! 
$ ! <sysdev>, which becomes CHAOS$DISK, is the disk where the files necessary
$ ! for the operation of the CHAOSnet software live.  These files need to be
$ ! online any time the CHAOSnet is in use.  It is defaultly the same as
$ ! SYS$SYSDEVICE.  If it isn't, you should supply a second argument to this
$ ! procedure.
$ !
$ ! <srcdev>, which becomes CHAOS$SRCDISK, is the disk where the sources,
$ ! etc. live.  It is defaultly the same as CHAOS$DISK.  If it isn't, you
$ ! should supply a third argument to this proceedure.  These files can be
$ ! dismounted or deleted if you do not wish to refer to the source.
$ !
$ ! <objdev>, which becomes CHAOS$OBJDISK, is the disk where the intermediate
$ ! files (object files, listings, etc.) are kept.  It is defaultly the same
$ ! as CHAOS$SRCDISK.  If it isn't, you should supply a fourth argument to
$ ! this procedure.  These files are necessary when installing on a differing
$ ! version of the system, and should be saved (on tape, at least) but may be
$ ! deleted from disk once your CHAOSnet is installed and working. 
$ !
$ ! These device names can be supplied to this proceedure after the <table>
$ ! argument.  This should normally be SYSTEM unless you are debugging, in
$ ! which case it can be SUPERVISOR.  It is the type of logical name to
$ ! define.
$ !
$ ! The devices should be specified in the form "__DMA2:".
$ ! Rooted directory names can be used, but it isn't guaranteed to work in
$ ! future releases unless DEC allows rooted directories to point at a
$ ! second-level directory in a future update to VMS.
$ !
$ ! If <sysdev> is not supplied, it defaults from SYS$SYSDEVICE.  Each
$ ! of <srcdev> and <objdev> defaults from the parameter before it.
$ !
$ ! *PLEASE NOTE*:  Due a VMS problem with logical names and rooted
$ ! directories, the [CHAOS] directory must be at top level.
$ TABLE:=
$ IF P1 .NES. "" .AND. P1 .NES. "." -
      THEN TABLE := "/''P1'" !E.g. @CHNAMES SYSTEM ...
$ !
$ SYSDISK:='F$LOGICAL("SYS$SYSDEVICE")
$ IF P2 .NES. "" THEN SYSDISK:='P2
$ !
$ SRCDISK:='SYSDISK
$ IF P3 .NES. "" THEN SRCDISK:='P3
$ !
$ OBJDISK:='SRCDISK
$ IF P4 .NES. "" THEN OBJDISK:='P4
$ !
$ ! Define logical names for where CHAOS software lives.
$ !
$ ! a) The disk on which the executable code ([CHAOS.EXE], [CHAOS.RFC])
$ !    and essential databases ([CHAOS.HOST.TABLES], [CHAOS.LOG], [CHAOS.DUMPS],
$ !    [CHAOS.TEMP]) are kept. This should be a disk which is never dismounted.
$ ASSIGN 'TABLE 'SYSDISK CHAOS$DISK
$ !
$ ! b)  Where all the other CHAOSnet source files are kept.  This includes
$ !	all the [CHAOS] subdirectories except possibly those on CHAOS$DISK
$ !	and [CHAOS.LIB].
$ ASSIGN 'TABLE 'SRCDISK CHAOS$SRCDISK
$ !
$ ! c)  Where the intermediate files (libraries, objects, listings) are put.
$ !     If different from CHAOS$SRCDISK, this device should the same [CHAOS]
$ !	sub-directory structure as CHAOS$SRCDISK, plus the [CHAOS.LIB] 
$ !	directory.
$ ASSIGN 'TABLE 'OBJDISK CHAOS$OBJDISK
$ !
$ ! d)  Directory where the CHAOSnet source and object libraries are kept
$ ASSIGN 'TABLE CHAOS$OBJDISK:[CHAOS.LIB] CHAOS$LIBRARY
$ !
$ ! e)  Where to put temporary files for compilations, server temporaries,
$ !	etc.  This is normally CHAOS$DISK:[CHAOS.TEMP] and should be on
$ !     a disk which is never dismounted.
$ ASSIGN 'TABLE CHAOS$DISK:[CHAOS.TEMP] CHAOS$TEMP
$ !
$ ! f)  Directory to keep the executable programs, drivers, etc.
$ !     This is normally CHAOS$DISK:[CHAOS.EXE], and must be on a
$ !	disk which is never dismounted.
$ ASSIGN 'TABLE CHAOS$DISK:[CHAOS.EXE] CHAOS$SYSTEM
$ !
$ ! g)  Directory to keep the executable automatically-started servers.
$ !	This is normally CHAOS$DISK:[CHAOS.RFC], and must be on a
$ !     disk which is never dismounted.
$ ASSIGN 'TABLE CHAOS$DISK:[CHAOS.RFC] CHAOS$RFC
