$ !
$ ! Start up the NCP process.  Note that the UIC [4,200] (or one that you
$ ! substitute) must be given diskquota on CHAOS$DISK: for NCP error logging
$ ! to occur.  A few hundred blocks of quota should be sufficient.  The current
$ ! log file can be closed with the program [CHAOS.NCP]NCPERRFMT, and the logs
$ ! purged, as necessary.
$ !
$ ! Privs needed to start up the NCP
$ SET PROC/PRIV=(SETPRV,ALTPRI,DETACH,PSWAPM)
$ !
$ ! The NCP's quota needs are as follows:  (see note)
$ !   IO_BUFFERED:  1 for each each device read:
$ !			CHNCP$COMMAND, CHNCP$TERM_MBX, PC:, CH:, NI:
$ !		    1 for PC write, 1 for NI write, 1 for logfile write
$ !		    1 for writing to each connection (plus a few extra).
$ !   BUFFER_LIMIT: 1 page for each WRITE operation above, plus some overhead.
$ !   AST_LIMIT:    1 for each IO_BUFFERED, plus several for timers and such.
$ !
$ ! (note:  Per-connection quotas are not actually used unless the connection
$ !  is actively in use.  Currently, however, the NCP can become deadlocked
$ !  if it runs out of quota, so if it is necessary to limit the resource
$ !  consumption of the NCP, I believe it is better to limit the number of
$ !  connections.  The resources in question, however, really should be being
$ !  charged to the user of the connection, not the NCP.  The NCP doesn't
$ !  actually use 16384 bytes of quota, but in theory it COULD.)
$ RUN CHAOS$SYSTEM:CHNCP /PROC="CHAOSNET_NCP"/UIC=[4,200] -
/IO_BUFFERED=32/FILE_LIMIT=32/AST_LIMIT=40/QUEUE_LIMIT=20 -
/BUFFER_LIMIT=16384/PRIV=(SETPRV,PHY_IO,PRMMBX,SYSNAM,WORLD,DETACH,ALTPRI) -
/PRIORITY=10/NOSWAP -
/WORKING_SET=120/MAXIMUM_WORKING_SET=250
