$ TYPE SYS$INPUT:

	This is PART 1 of the installation command procedure for 
	the VMS CHAOSnet software V4.3 - this part creates the 
	necessary startup command procedure for the net.  Part 2
	is the invocation of the file created here.  More details to 
	come.

	Before proceeding any further, make sure that all hardware
	has been installed and that the network host table has been
	properly configured (see [CHAOS.DOC]HOSTLIB.TXT).

	[Note: If you go through this procedure and the network does
	not seem to be alive, then it may be that there are problems
	with the hardware.  There are test programs for testing
	out CHAOS and INTERLAN hardware available in this kit.  The 
	former is the program [CHAOS.DRIVER]PCTEST which must be linked
	on this system; the latter is [CHAOS.DRIVER.INTERLAN]NITEST which 
	must be relinked also.  Stop the process CHAOSNET_NCP and run
	the programs - if they complete, then the hardware and drivers
	are OK.  For PCTEST to complete, another node must issue a 
	STATUS (HOSTAT) request to this system. NITEST should be run
	on an idle ethernet if possible.]

$ OPEN/WRITE tmp chstart.tmp
$ WT = "WRITE TMP"
$ ON ERROR THEN GOTO ERROR_EXIT
$ ON CONTROL_Y THEN GOTO ERROR_EXIT
$!
$!
$!
$ INQUIR winp "First, are you running from an account with SETPRV?"
$ if winp then goto 10$
$ TYPE SYS$INPUT:
** You need lots of privs to run this, including CMKRNL.  Best to have SETPRV.
$ GOTO ERROR_EXIT
$10$:
$ WT "$ !"
$ WT "$ ! Command file to load and startup CHAOSnet"
$ WT "$ !"
$ WT "$ ! The following privs are needed to execute this command proceedure"
$ WT "$ SET PROC/PRIV=(SYSNAM,CMKRNL,CMEXEC,DETACH,SETPRV,ALTPRI,PSWAPM)"
$!
$!	Now need to add CHNAMES stuff
$!
$ chnmstr = ""
$ TYPE SYS$INPUT:

We need to define logical names which point to where the various pieces
of the CHAOS kit reside - specify all devices in the form "__DBA0:", see
[CHAOS]CHNAMES.COM for more information

$ INQUIR onedisk "Will all of the CHAOS files be residing on the same disk? "
$ IF (.NOT. onedisk) THEN GOTO MULTI_DISK
$ INQUIR disk "Which disk (<CR> gets default, SYS$SYSDEVICE)? "
$ chnmstr = disk
$ GOTO ADD_CHNAMES
$MULTI_DISK:
$ INQUIR sysdev "Which disk will the CHAOS executables reside on? "
$ INQUIR srcdev "Which disk will the CHAOS sources reside on? "
$ INQUIR objdev "Which disk will the CHAOS objects reside on? "
$ chnmstr = sysdev+" "+srcdev+" "+objdev
$ADD_CHNAMES:
$ WT "$ !"
$ WT "$ ! Define logical names for where CHAOS software lives."
$ WT "$ ! The format is @CHNAMES SYSTEM [<sysdev> [<srcdev> [<objdev>]]]"
$ WT "$ ! See CHNAMES.COM for details."
$ WT "$ @SYS$MANAGER:CHNAMES SYSTEM ",chnmstr
$ WT "$ !"
$!
$!	Now add tape stuff
$!
$ADD_TAPE:
$ TYPE SYS$INPUT:

We will now add the necessary commands to support remote tape access - read
the comments in the file we're producing here (CHSTART.COM) for more details

$ INQUIR mtape "Do you have a tape drive? "
$ IF (.NOT. mtape) THEN GOTO DO_DEVICES 
$ INQUIR mtname "If your magtape device is not _MTA0: then specify its name"
$ IF mtname .EQS. "" THEN mtname = "_MTA0:"
$ WT "$ !"
$ WT "$ ! Define the defaults for the Remote Tape Facility:"
$ WT "$ ! If the name CHAOS$RTAPE_DEFAULTS exists, it has the form"
$ WT "$ !"
$ WT "$ !		""drive/option...""  "
$ WT "$ !"
$ WT "$ ! An option is one of ASSIST, NOASSIST, READ_CHECK, NOREAD_CHECK,"
$ WT "$ ! WRITE_CHECK, or NOWRITE_CHECK."
$ WT "$ ! The ""drive"", if present, is the default drive to use if the user does not"
$ WT "$ ! specify one, or if he only specifies a unit number.  If only options are"
$ WT "$ ! present, then there is no default drive and users will have to specify a"
$ WT "$ ! drive with each use of the Remote Tape Facility."
$ WT "$ DEFINE/SYSTEM CHAOS$RTAPE_DEFAULTS """,mtname,"/NOASSIST/READ_CHECK/WRITE_CHECK"" "
$!
$!	Now add the network devices, starting with the CH pseudo
$!	devices which are used for the inter-process communication 
$!	between user/server processes and the NCP
$!
$DO_DEVICES:
$ WT "$ !"
$ WT "$ ! The following loads the drivers for the CHAOSnet.  PC is the physical"
$ WT "$ ! CHAOSnet hardware, while CH is the logical CHAOSnet connection device."
$ WT "$ ! One CH unit per connection is the rule, plus one for the NCP. MAXUNITS"
$ WT "$ ! can be adjusted (it is octal), and more or fewer CHAn units connected"
$ WT "$ ! as appropriate for your site.  NI is the physical INTERLAN ETHERNET"
$ WT "$ ! hardware."
$ WT "$ !"
$ WT "$ RUN SYS$SYSTEM:SYSGEN"
$ WT "LOAD CHAOS$SYSTEM:CHDRIVER"
$ WT "CONNECT CHA0 /NOADAPT/NUMVEC=1/MAXUNITS=20"
$ WT "CONNECT CHA1 /NOADAPT/NUMVEC=1"
$ WT "CONNECT CHA2 /NOADAPT/NUMVEC=1"
$ WT "CONNECT CHA3 /NOADAPT/NUMVEC=1"
$ WT "CONNECT CHA4 /NOADAPT/NUMVEC=1"
$ WT "CONNECT CHA5 /NOADAPT/NUMVEC=1"
$ WT "CONNECT CHA6 /NOADAPT/NUMVEC=1"
$ WT "CONNECT CHA8 /NOADAPT/NUMVEC=1"
$ WT "CONNECT CHA9 /NOADAPT/NUMVEC=1"
$ WT "CONNECT CHA10 /NOADAPT/NUMVEC=1"
$ WT "CONNECT CHA11 /NOADAPT/NUMVEC=1"
$ WT "CONNECT CHA12 /NOADAPT/NUMVEC=1"
$ WT "CONNECT CHA13 /NOADAPT/NUMVEC=1"
$ WT "CONNECT CHA14 /NOADAPT/NUMVEC=1"
$ WT "CONNECT CHA15 /NOADAPT/NUMVEC=1"
$ WT "EXIT"
$!
$!	Init config code to indicate no hardware interfaces - at the end,
$!	a code of 1 will mean we only have the PC device; a code of 2 will
$!	mean we have only the NI; and a code of 3 will mean we have both
$!
$ config = 0
$!
$ TYPE SYS$INPUT:


Now it is time to define the hardware interfaces to be used

$ INQUIR pcp "Do you have a CHAOS hardware interface that you want configured? "
$ IF (.NOT. pcp) THEN GOTO GET_NI
$ TYPE SYS$INPUT:

Before proceeding, make sure that the CHAOS interface is installed properly
at a UNIQUE CSR address, with a UNIQUE interrupt VECTOR

$!
$GET_PC_CSR:
$ INQUIR pccsr "What is the CSR address (in octal) for your CHAOS interface? "
$!
$!	Do some cursory bounds checking
$!
$ IF pccsr .LT. 777777 THEN GOTO  12$ 
$ TYPE SYS$INPUT
** ERROR
**
** That is not a legal CSR address - it is greater than 777777 octal
**
$ GOTO GET_PC_CSR
$12$:
$ IF pccsr .GT. 700000 THEN GOTO GET_PC_VEC
$ TYPE SYS$INPUT
** ERROR
**
** That is not a legal CSR address - it is less than 700000 octal
**
$ GOTO GET_PC_CSR
$!
$GET_PC_VEC:
$ INQUIR pcvec "What is the Interrupt VECTOR (octal) for the CHAOS interface? "
$GET_PC_UB:
$ INQUIR pcub "Which UNIBUS adapter (e.g. UB0) is the CHAOS interface on? "
$ IF F$EXTRACT(0,2,pcub) .EQS. "UB" THEN GOTO LOAD_PC
$ TYPE SYS$INPUT
** ERROR
** 
** Invalid syntax for UNIBUS adapter specification - specify something of the
form "UBx".  For example, if you are on a system with only one UNIBUS, then
specify "UB0" - if you're using the second UNIBUS on a system with two, then
specify "UB1"
**
$ GOTO GET_PC_UB
$!
$!	Now add the lines to load and configure the PC device
$!
$LOAD_PC:
$ WT "$ RUN SYS$SYSTEM:SYSGEN"
$ WT "LOAD CHAOS$SYSTEM:PCDRIVER"
$ WT "CONNECT PCA0 /ADAP=",pcub,"/CSR=%O",pccsr,"/VEC=%O",pcvec
$ WT "EXIT"
$ !
$GET_PC_ADD:
$ INQUIRE pcadd "What is the 16-bit network address (octal) of this interface? "
$ primadd = pcadd
$ WT "$ DEFINE/SYS CHNCP$CHAOS0 ",pcadd
$!
$!	Update config code
$!
$ config = config + 1
$!
$!	Now deal with the INTERLAN interface
$!
$GET_NI:
$ TYPE SYS$INPUT:

$ INQUIR nip "Do you have an INTERLAN ETHERNET interface that you want configured? "
$ IF (.NOT. nip) THEN GOTO END_OF_DEVICES
$ TYPE SYS$INPUT:

Before proceeding, make sure that the INTERLAN interface is installed properly
at a UNIQUE CSR address, with a UNIQUE interrupt VECTOR

$!
$GET_NI_CSR:
$ INQUIR nicsr "What is the CSR address (in octal) for your INTERLAN interface? "
$!
$!	Do some cursory bounds checking
$!
$ IF nicsr .LT. 777777 THEN GOTO  13$ 
$ TYPE SYS$INPUT
** ERROR
**
** That is not a legal CSR address - it is greater than 777777 octal
**
$ GOTO GET_NI_CSR
$13$:
$ IF nicsr .GT. 700000 THEN GOTO GET_NI_VEC
$ TYPE SYS$INPUT
** ERROR
**
** That is not a legal CSR address - it is less than 700000 octal
**
$ GOTO GET_NI_CSR
$!
$GET_NI_VEC:
$ INQUIR nivec "What is the Interrupt VECTOR (octal) for the INTERLAN interface? "
$GET_NI_UB:
$ INQUIR niub "Which UNIBUS adapter (e.g. UB0) is the INTERLAN interface on? "
$ IF F$EXTRACT(0,2,niub) .EQS. "UB" THEN GOTO LOAD_NI
$ TYPE SYS$INPUT
** ERROR
**
** Invalid syntax for UNIBUS adapter specification - specify something of the
form "UBx".  For example, if you are on a system with only one UNIBUS, then
specify "UB0" - if you're using the second UNIBUS on a system with two, then
specify "UB1"
**
$ GOTO GET_NI_UB
$!
$!	Now add the lines to load and configure the ni device
$!
$LOAD_NI:
$ WT "$ RUN SYS$SYSTEM:SYSGEN"
$ WT "LOAD CHAOS$SYSTEM:NIDRIVER"
$ WT "CONNECT NIA0 /ADAP=",niub,"/CSR=%O",nicsr,"/VEC=%O",nivec,"/NUMVEC=2"
$ WT "EXIT"
$!
$GET_NI_ADD:
$ INQUIRE niadd "What is the 16-bit network address (octal) of this interface? "
$ primadd = niadd
$ WT "$ DEFINE/SYS CHNCP$INTERLAN0 ",niadd
$!
$!	Update config
$!
$ config = config + 2
$!
$END_OF_DEVICES:
$ IF config .GT. 0 THEN GOTO 15$
$ TYPE SYS$INPUT:
** INFORMATION
**
** You have not configured any devices - this procedure will now terminate
**
$ GOTO ERROR_EXIT
$!
$!	We do have at least one device
$!
$15$:
$ IF config .EQ. 3 THEN GOTO GET_PRIM_ADD
$ WT "$ DEFINE/SYS CHNCP$PRIMARY ",primadd
$ GOTO GET_GMT_DSP
$GET_PRIM_ADD:
$ TYPE SYS$INPUT:

You have configured more than one interface - you must now decide which
one will be the primary interface.  The address of the primary interface
should correspond to the first address specified in the network host
table on this and all other systems trying to access this system over the
network.  The host table for this VMS system should be in 

		CHAOS$DISK:[CHAOS.HOST.TABLES]NETHOSTS.TXT

where "CHAOS$DISK" is a logical name for the device which contains the
CHAOS software.

$PROMPT_PRIM_ADD:
$ INQUIR primadd "What is the primary network address (octal) for this system? "
$ IF primadd .EQ. pcadd THEN GOTO PRIM_ADD_OK
$ IF primadd .EQ. niadd THEN GOTO PRIM_ADD_OK
$ TYPE SYS$INPUT:
** ERROR
**
** The primary address must be the same as one of the two addresses you
** have already specified for your interfaces:
**
$ WRITE SYS$OUTPUT "** CHAOS address:    ",pcadd
$ WRITE SYS$OUTPUT "** INTERLAN address: ",niadd
$ TYPE SYS$INPUT:
**
$ GOTO PROMPT_PRIM_ADD
$PRIM_ADD_OK:
$ WT "$ DEFINE/SYS CHNCP$PRIMARY ",primadd
$!
$!	See about bridging - since we have multiple node
$!
$ TYPE SYS$INPUT:

One of the features of the VMS CHAOSnet software is that any node attached
to multiple subnets may act as a bridge between the subnets - that is, pass
packets from a node on one subnet to a node on another.  This is accomplished
by the broadcasting of routing packets.

By default, the NCP will broadcast routing packets if the current node is
attached to more than one subnet.  This may not always be desirable, and if
if it not it is necessary to define a logical name at startup time which 
will disable bridging.

$ brdgflag = ""
$ INQUIR bridg "So, do you want to have bridging capability ENABLED? "
$ IF  bridg THEN brdgflag = "!"
$ WT "$ !"
$ WT "$ ! The logical name CHNCP$NOBRIDGE controls whether this node will "
$ WT "$ ! act as a network bridge, forwarding packets from one subnet to "
$ WT "$ ! another. Mainly this equates to the broadcasting of routing table"
$ WT "$ ! info.  By default, any node which has more than one interface (as"
$ WT "$ ! defined by the previous logical names) will broadcast routing table"
$ WT "$ ! packets and act as a bridge.  To overide this function, define the"
$ WT "$ ! logical name CHNCP$NOBRIDGE to RESOLVE TO ANYTHING! This is key - the"
$ WT "$ ! NCP only checks for the existence of the logical name in the logical" 
$ WT "$ ! name table - the actual equivalence string is ignored (e.g., "
$ WT "$ ! a) $DEFINE/SYSTEM CHNCP$NOBRIDGE ""YES"" and"
$ WT "$ ! b) $DEFINE/SYSTEM CHNCP$NOBRIDGE ""NO"" are equivalent to the NCP, and"
$ WT "$ ! either will disable bridging)."
$ WT "$ !"
$ WT "$ ",brdgflag,"DEFINE/SYSTEM CHNCP$NOBRIDGE ""BRIDGING_OFF"" "
$ WT "$ !"
$!
$!	Now deal with time-zone displacement from GMT
$!
$GET_GMT_DSP:
$ TYPE SYS$INPUT


Now we need to take care of a few trivial matters

$ weflag = ""
$ INQUIR wstorest "Are you located West or East of Greenwich, England? "
$ IF F$EXTRACT(0,1,wstorest) .EQS. "E" THEN weflag = "-"
$ INQUIRE gmtdsp "How far are you from Greenwich (in timezones)? "
$ IF F$LENGTH(gmtdsp) .EQ. 1 THEN gmtdsp = "0"+F$STRING(gmtdsp)
$ WT "$ !"
$ WT "$ ! Define site's local time zone characteristics:"
$ WT "$ !"
$ WT "$ ! a) GMT_DSP is displacement west of GMT, in delta time format."
$ WT "$ DEFINE/SYSTEM GMT_DSP  ""0 ",weflag,gmtdsp,":00:00.0"" "
$!
$!
$!
$ INQUIRE dst "Is daylight savings time applicable to your timezone? "
$ WT "$ !"
$ WT "$ ! b) DST_SITE should be "ON" if this site is currently in a time zone"
$ WT "$ !    which is using daylight savings time.  Otherwise it should be "OFF" "
$ WT "$ !    or not defined at all."
$ WT "$ !*************************************************************************"
$ WT "$ !Note: This is a modification from previous releases - the DST_SITE logical"
$ WT "$ !	 should translate to "ON" ONLY WHEN DAYLIGHT SAVINGS TIME IS ACTUALLY"
$ WT "$ !	 IN EFFECT.  This sacrifice of user-friendliness is due to the "
$ WT "$ !	 inclusion of the TIME server in the code executed by the NCP, which"
$ WT "$ !	 results in significant performance inprovement - the automatic"
$ WT "$ !	 evaluation of the current state of DST, based on date, may return"
$ WT "$ !	 in a future release. "
$ WT "$ !*************************************************************************"
$ IF dst THEN $ WT "$ DEFINE/SYSTEM DST_SITE ""ON"" "
$ IF (.NOT. dst) THEN $ WT "$DEFINE/SYSTEM DST_SITE ""OFF"" "
$!
$!
$!
$ TYPE SYS$INPUT:

You will have to alter the definition of the logical name DST_SITE in
the file that we are creating here (SYS$MANAGER:CHSTART.COM) depending on
the current state of daylight savings time - read the comments in the file
for more details

$!
$!	Now add the stuff to install the various images and start the NCP
$!
$ WT "$ !"
$ WT "$ ! Install software that needs it"
$ WT "$ RUN SYS$SYSTEM:INSTALL"
$ WT "CHAOS$RFC:MAIL/SHARED/OPEN/HEADER_RESIDENT"
$ WT "CHAOS$RFC:NAME/SHARED/OPEN/HEADER_RESIDENT/PRIV=(CMEXEC,WORLD,SYSPRV)"
$ WT "CHAOS$RFC:SEND/SHARED/OPEN/HEADER_RESIDENT"
$ WT "CHAOS$RFC:SINK/SHARED/OPEN/HEADER_RESIDENT"
$ WT "CHAOS$RFC:TELNET/SHARED/OPEN/HEADER_RESIDENT/PRIV=(PHY_IO,TMPMBX,NETMBX)"
$ WT "CHAOS$RFC:FILE/SHARED/OPEN/HEADER_RESIDENT"
$ WT "CHAOS$SYSTEM:CFTP/SHARED/OPEN/HEADER_RESIDENT"
$ WT "CHAOS$SYSTEM:QSEND/SHARED/OPEN/HEADER_RESIDENT/PRIV=(SYSPRV,WORLD,OPER)"
$ WT "CHAOS$SYSTEM:STATUS/SHARED/OPEN/HEADER_RESIDENT"
$ WT "CHAOS$SYSTEM:SUPDUP/SHARED/OPEN/HEADER_RESIDENT"
$ WT "CHAOS$SYSTEM:TELUSR/SHARED/OPEN/HEADER_RESIDENT"
$ WT "$!"
$ WT "$!	Now start the NCP process"
$ WT "$!"
$ WT "$ @SYS$MANAGER:CHRESTART"
$!
$!	Last comments
$!
$ INQUIR winp "Is this VMS version 3.0 or greater?"
$ if winp then goto 25$
$ TYPE SYS$INPUT:
This software cannot be run on versions of VMS prior to 3.0.
$ GOTO ERROR_EXIT
$!
$!	Success - copy all files needed to SYS$MANAGER
$!
$25$:
$30$:
$CLOSE_UP_AND_GO:
$!
$ CLOSE TMP
$ COPY CHSTART.TMP SYS$MANAGER:CHSTART.COM
$ COPY CHLOGIN.COM SYS$MANAGER:CHLOGIN.COM
$ COPY CHNAMES.COM SYS$MANAGER:CNAMES.COM
$ COPY CHRESTART.COM SYS$MANAGER:CHRESTART.COM
$ TYPE SYS$INPUT:

So far so good - you now have a several command files in SYS$MANAGER that
you should peruse as a sanity check:

	CHSTART.COM which is the file we just built - it should bear a
		    resemblance to the one in [CHAOS], which is the
		    example file shipped with the kit

	CHLOGIN.COM which contains some usefule symbol definitions - you
		    should add the command "$ @SYS$MANAGER:CHLOGIN" to
		    the LOGIN.COM of all the users on this system who will
		    make use of the network 

$ INQUIR x "Type <CR> to continue"
$ TYPE SYS$INPUT:

	CHNAMES.COM which is called by CHSTART.COM, but which can be invoked
		    at any time to change the system logical names which
		    describe where the various files in the CHAOS kit reside


	CHRESTART.COM which actually kicks off the NCP (it is invoked by
		      CHSTART.COM)


To start your network up - just invoke SYS$MANAGER:CHSTART

Once you are satisfied that the startup procedures work correctly, and that
your network is functioning properly, add the line "$ @SYS$MANAGER:CHSTART"
to the file SYS$MANAGER:SYSTARTUP.COM.

End of startup build procedure

$ EXIT 1
$ERROR_EXIT:
$ CLOSE TMP
$ DELETE CHSTART.TMP;
$ EXIT
