;;;-*-mode:lisp; package:user; base:10.-*-

(defvar *array-size* 10000.)
(defvar *file-size* 100000.)
(defvar *test-file* "iu:usr:[quam]foo.tmp")

(defun make-big-file(&optional (name *test-file*) (size *file-size*))
  (with-open-file (stream name '(:out :fixnum))	; probably no reason for file to be fixnum 
    (let ((array (make-array *array-size* ':type ':art-16b)))
      (loop for i from 0 below size by *array-size*
	    do (funcall stream ':string-out array)))))


(defun read-big-file(&optional (name *test-file*) (size *file-size*))
  (error-restart (sys:network-error "retry file read")
    (with-open-file (stream name '(:in :fixnum))
      (let ((array (make-array *array-size* ':type ':art-16b)))
	(loop for i from 0 below size by *array-size*
	      until  (second (multiple-value-list (funcall stream ':string-in nil array))))))))

(make-big-file)

(loop do (read-big-file))
